type op = Add | Sub | Mul | Div | Equal | Neq | Less | Leq | Greater | Geq | And | Or | Power |Emul |Erdiv |Ldiv|Eldiv


type expr =
    Literal of int
  | Floatlit of float 
  | Bool of string
  | Paren of expr
  | Id of string
  | Datatype of string
  | String of string
  | Binop of expr * op * expr
  | Transpose of expr
  | Uminus of expr
  | Not of expr 
  | Assign of string * expr     
  | Call of string * expr list
  | AssignMatrix of string*expr list*expr
  | MatrixAccess of string*expr list
  | MatrixRAccess of string*expr*expr*expr*expr
  | Newmat of expr*expr
 
    
type for_expr = 
    Assigna of string * expr * expr
  | Assignb of string * expr * expr * expr
  


type stmt =
    Block of stmt list
  | Expr of expr
  | Break
  | Continue
  | MatrixInit of string * expr list list
  | If of expr * stmt * stmt
  | Ifelseif of expr * stmt * elseif list * stmt
  | For of for_expr * stmt
  | While of expr * stmt
and elseif = {
    elseif_expr : expr;
    elseif_stmt : stmt;
  }
  


type var_decl = {
    varname : string;
    vartype : string;
  }

type func_decl = {
    fname : string;
    rettype : string;
    retname : string;
    formals : var_decl list;
    locals : var_decl list;
    body : stmt list;
  }

type program = var_decl list * func_decl list
