

import java.io.File;

import java.util.Formatter;

import java.util.Scanner;

import Jama.*;

public class test_matrix_range {

enum OPERATION {ADD, SUB, MUL, DIV, EMUL, ELDIV, ERDIV, LDIV, POW};
static String numFormat = "short";
    static void setNumFormat(String s){
        numFormat=s;
    }
    static void disp(Object o) {
        if (o instanceof String) {
            System.out.println((String) o);
        } else if (o instanceof Integer) {
            Integer a = (Integer) o;
            System.out.println(a.toString());
        } else if (o instanceof Double) {
            if (numFormat.equals("short")) {
                String fString = "%" + "01" + "." + 4 + "f\n";
                Double a = (Double) o;
               System.out.format(fString, a);
            } else if (numFormat.equals("shortE")) {
                String fString = "%" + "1" + "." + 4 + "E";
                Double a = (Double) o;
                System.out.format(fString, a);
            }else if (numFormat.equals("long")){
                String fString = "%" + "1" + "." + 10 + "f";
                Double a = (Double) o;
                System.out.format(fString, a);
            }else if (numFormat.equals("longE")){
                String fString = "%" + "01" + "." + 10 + "E";
                Double a = (Double) o;
                System.out.format(fString, a);
            }
        }else if (o instanceof Matrix){
            Matrix m=(Matrix) o;
            String conversion="";
            int numDecimal=4;
            if (numFormat.equals("short") || numFormat.equals("shortE")){
                numDecimal=4;
                if (numFormat.equals("short")){
                    conversion="f";
                }else{
                    conversion="E";
                }
            }else if(numFormat.equals("long") || numFormat.equals("longE")){
                numDecimal=15;
                if (numFormat.equals("long")){
                    conversion="f";
                }else{
                    conversion="E";
                }
            }
            String formatStr="%"+"1"+"."+numDecimal+conversion;
            int maxWidth=0;
            for (int i=0; i<m.getRowDimension(); i++){
                for (int j=0; j<m.getColumnDimension(); j++){
                    String testStr=String.format(formatStr, m.get(i, j));
                   if (testStr.length()>maxWidth){
                        maxWidth=testStr.length();
                    }
                }
            }
           maxWidth+=6;
            for (int i=0; i<m.getRowDimension(); i++){
                for (int j=0; j<m.getColumnDimension(); j++){
                    formatStr="%"+maxWidth+"."+numDecimal+conversion;
                    String testStr=String.format(formatStr, m.get(i, j));
                    System.out.print(testStr);
                }
                System.out.println();
            }
        }
    }
    static Matrix matrixOperations(Object op1, Object op2, OPERATION op) {
        if (op1 instanceof Matrix && (op2 instanceof Integer || op2 instanceof Double)) {
            Matrix temp1 = (Matrix) op1;
            Matrix temp2 = new Matrix(temp1.getRowDimension(), temp1.getColumnDimension(), Double.parseDouble(op2.toString()));
            Matrix temp3=new Matrix(temp1.getRowDimension(), temp1.getColumnDimension());
            switch (op) {
                case ADD:
                    return temp1.plus(temp2);
                case SUB:
                    return temp1.minus(temp2);
                case MUL:
                    return temp1.times(Double.parseDouble(op2.toString()));
                case DIV:
                    for (int i = 0; i < temp1.getRowDimension(); i++) {
                        for (int j = 0; j < temp1.getColumnDimension(); j++) {
                            double product = temp1.get(i, j) / temp2.get(i,j);
                            temp3.set(i, j, product);
                        }
                    }
                    return temp3;
                case POW:
                    for (int i = 0; i < temp1.getRowDimension(); i++) {
                        for (int j = 0; j < temp1.getColumnDimension(); j++) {
                            double product = Math.pow(temp1.get(i, j), temp2.get(i,j));
                            temp1.set(i, j, product);
                        }
                    }
                    return temp1;
            }
          }else if((op1 instanceof Integer || op1 instanceof Double) && op2 instanceof Matrix) {
              Matrix temp1 = (Matrix) op2;
               Matrix temp2 = new Matrix(temp1.getRowDimension(), temp1.getColumnDimension(), Double.parseDouble(op1.toString()));
		Matrix temp3=new Matrix(temp1.getRowDimension(), temp1.getColumnDimension());
              switch (op) {
                case ADD:
                    return temp1.plus(temp2);
                case SUB:
                    return temp1.minus(temp2);
                case MUL:
                    return temp1.times(Double.parseDouble(op1.toString()));
                case DIV:
                    for (int i = 0; i < temp1.getRowDimension(); i++) {
                        for (int j = 0; j < temp1.getColumnDimension(); j++) {
                            double product = temp2.get(i, j) / temp1.get(i,j);
                            temp3.set(i, j, product);
                        }
                    }
                    return temp3;
               }
            }else if (op1 instanceof Matrix && op2 instanceof Matrix) {
            Matrix temp1 = (Matrix) op1;
            Matrix temp2 = (Matrix) op2;
            switch (op) {
                case ADD:
                    return temp1.plus(temp2);
                case SUB:
                    return temp1.minus(temp2);
                case MUL:
                    return temp1.times(temp2);
                case EMUL:
                    return temp1.arrayTimes(temp2);
                case ELDIV:
                    return temp1.arrayLeftDivide(temp2);
                case LDIV:
                    return temp1.solve(temp2);
                case ERDIV:
                    return temp1.arrayRightDivide(temp2);
            }
        }
        return null;
    }
static Matrix matrixInit(int row, int col, double [] array){
        double [][]m=new double[row][col];
        int arrayIndex=0;
        for (int i=0; i<row;i++ ){
            for (int j=0; j<col; j++){
               m[i][j]=array[arrayIndex];
                arrayIndex++;
            }
        }
        return new Matrix(m);
    }
public static int getHeight(Matrix M){
        return M.getRowDimension();
}
public static int getWidth(Matrix M){
        return M.getColumnDimension();
}
static Matrix getSubMatrix(Matrix M, int i0, int i1, int j0, int j1){
        int start1=0;
        int finish1=0;
        int start2=0;
        int finish2=0;
        if (i0==-1 && i1==-1){
            start1=0;
            finish1=M.getRowDimension();
        }else{
            start1=i0;
            finish1=i1;
        }
        if (j0==-1 && j1==-1){
            start2=0;
            finish2=M.getColumnDimension();
        }else{
            start2=j0;
            finish2=j1;
        }
        return M.getMatrix(start1, finish1, start2, finish2);
}
    public static String[] getFields(String line, String delimiters) {
        java.util.StringTokenizer st = new java.util.StringTokenizer(line, delimiters);
        int fieldCnt = st.countTokens();
        String[] fields = new String[fieldCnt];
        for (int i = 0; i < fieldCnt; i++) {
            fields[i] = st.nextToken();
        }
        return fields;
    }
    public static void save(Matrix data, String name) {
        File outputFile = new File("." + File.separator + name + ".mat");
        Formatter output = null;
        try {
            output = new Formatter(outputFile);
        } catch (Exception e) {
            e.printStackTrace();
        }
        output.format("%d,%d\n", data.getRowDimension(), data.getColumnDimension());
        for (int i = 0; i < data.getRowDimension(); i++) {
            for (int j = 0; j < data.getColumnDimension(); j++) {
                output.format("%e", data.get(i, j));
                if (j != data.getColumnDimension() - 1) {
                    output.format("%s", ",");
                }
            }
            output.format("%s\n", "");
        }
        output.flush();
        output.close();
    }
    public static Matrix load( String name) {
        File inputFile = new File("." + File.separator + name + ".mat");
        Scanner input=null;
        String lStr="";
        try {
            input=new Scanner(inputFile);
        } catch (Exception e) {
           e.printStackTrace();
       }
       String []fields;
       lStr=input.nextLine();
        fields=getFields(lStr,",");
        int nRows=Integer.parseInt(fields[0]);
        int nCols=Integer.parseInt(fields[1]);
        double [][] inputM=new double[nRows][nCols];
        for (int i=0; i<nRows; i++){
            lStr=input.nextLine();
            fields=getFields(lStr,",");
            for (int j=0; j<nCols; j++){
                inputM[i][j]=Double.parseDouble(fields[j]);
            }
        }
        Matrix oM=new Matrix(inputM);
        return oM;
    }

public static void main(String[] args)
{
Matrix m = new Matrix(1,1);
Matrix s = new Matrix(1,1);
Integer i = 0;
m = new Matrix(2, 6);
for (i = 0 ; i <= 5 ; i++){
m.set(0, i, i);
}
for (i = 0 ; i <= 5 ; i++){
m.set(1, i, i * 2);
}
s = getSubMatrix(m, 0, 1, 3, 4);
disp("m=");
disp(m);
disp("m(0:1,3:4)=");
disp(s);
disp("m(:,:):");
}

}

